/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package finalpecha;

import javax.swing.JOptionPane;

/**
 *
 * @author Maka
 */
public class Principal extends javax.swing.JFrame {
     private Alquiler alquiler;
    /**
     * Creates new form Principal
     */
    public Principal() {
        initComponents();
        alquiler = new Alquiler();
        btnReportes.setEnabled(false);
        rbtViento.setSelected(true);
        txtCantidadCuerdas.setEnabled(false);
    }
    
    public boolean validation(){
        if (txtNombreCliente.getText().isEmpty()){
            JOptionPane.showMessageDialog(null, "El Nombre del Cliente debe agregarse");
            txtNombreCliente.requestFocus();
            return false;
        }
        if (txtNombreInstrumento.getText().isEmpty()){
            JOptionPane.showMessageDialog(null, "El Nombre del Instrumento debe agregarse");
            txtNombreInstrumento.requestFocus();
            return false;
        }
        if (txtCantidadSemanas.getText().isEmpty()){
            JOptionPane.showMessageDialog(null, "La Cantidad de Semanas debe agregarse");
            txtCantidadSemanas.requestFocus();
            return false;
        }
        if (rbtCuerdas.isSelected()){
            if(txtCantidadCuerdas.getText().isEmpty()){
                JOptionPane.showMessageDialog(null, "La Cantidad de Cuerdas debe agregarse");
                txtCantidadCuerdas.requestFocus();
                return false;
            }
        }
        return true;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txtNombreCliente = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txtCantidadSemanas = new javax.swing.JTextField();
        txtCantidadCuerdas = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        txtNombreInstrumento = new javax.swing.JTextField();
        btnGuardar = new javax.swing.JButton();
        btnReportes = new javax.swing.JButton();
        rbtCuerdas = new javax.swing.JRadioButton();
        rbtViento = new javax.swing.JRadioButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("Carga de Instrumentos");

        jLabel2.setText("Nombre Cliente");

        jLabel3.setText("Nombre Instrumento");

        jLabel4.setText("Cantidad Semanas");

        txtCantidadSemanas.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                txtCantidadSemanasFocusLost(evt);
            }
        });

        txtCantidadCuerdas.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                txtCantidadCuerdasFocusLost(evt);
            }
        });

        jLabel5.setText("Cantidad Cuerdas");

        btnGuardar.setText("Guardar");
        btnGuardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGuardarActionPerformed(evt);
            }
        });

        btnReportes.setText("Ver Reportes");
        btnReportes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnReportesActionPerformed(evt);
            }
        });

        buttonGroup1.add(rbtCuerdas);
        rbtCuerdas.setText("Cuerdas");
        rbtCuerdas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtCuerdasActionPerformed(evt);
            }
        });

        buttonGroup1.add(rbtViento);
        rbtViento.setText("Viento");
        rbtViento.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtVientoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(65, 65, 65)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(109, 109, 109)
                                .addComponent(btnGuardar))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(rbtViento)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jLabel2)
                                        .addComponent(jLabel3)
                                        .addComponent(jLabel4)
                                        .addComponent(jLabel5)))
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGap(97, 97, 97)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                            .addComponent(btnReportes)
                                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                .addComponent(txtNombreCliente)
                                                .addComponent(txtNombreInstrumento)
                                                .addComponent(txtCantidadSemanas)
                                                .addComponent(txtCantidadCuerdas, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE))))
                                    .addGroup(layout.createSequentialGroup()
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(rbtCuerdas)
                                        .addGap(28, 28, 28))))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(145, 145, 145)
                        .addComponent(jLabel1)))
                .addContainerGap(132, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(21, 21, 21)
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rbtCuerdas)
                    .addComponent(rbtViento))
                .addGap(24, 24, 24)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtNombreCliente, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtNombreInstrumento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtCantidadSemanas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtCantidadCuerdas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 28, Short.MAX_VALUE)
                .addComponent(btnGuardar)
                .addGap(18, 18, 18)
                .addComponent(btnReportes)
                .addGap(39, 39, 39))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnGuardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGuardarActionPerformed
        if (validation()) {
            String nombreCliente = txtNombreCliente.getText();
            String nombreInstrumento = txtNombreInstrumento.getText();
            int cantidadSemanas = Integer.parseInt(txtCantidadSemanas.getText());

            if(rbtViento.isSelected()){
                InstrumentoViento iv = new InstrumentoViento(nombreCliente, nombreInstrumento, cantidadSemanas);
                alquiler.agregarInstrumento(iv);
            } else {
                int cantidadCuerdas = Integer.parseInt(txtCantidadCuerdas.getText());
                InstrumentoCuerda ic = new InstrumentoCuerda(nombreCliente, nombreInstrumento, cantidadSemanas, cantidadCuerdas);
                alquiler.agregarInstrumento(ic);
            }

            txtNombreCliente.setText("");
            txtNombreInstrumento.setText("");
            txtCantidadSemanas.setText("");
            txtCantidadCuerdas.setText("");
            btnReportes.setEnabled(true);
        }
    }//GEN-LAST:event_btnGuardarActionPerformed

    private void rbtVientoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtVientoActionPerformed
        txtCantidadCuerdas.setEnabled(false);
    }//GEN-LAST:event_rbtVientoActionPerformed

    private void rbtCuerdasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtCuerdasActionPerformed
        txtCantidadCuerdas.setEnabled(true);
    }//GEN-LAST:event_rbtCuerdasActionPerformed

    private void btnReportesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnReportesActionPerformed
        String clienteAlquilerMayor = String.valueOf(alquiler.ClienteAlquilerMayor());
        String totalGanadoSinDesinfeccion = String.valueOf(alquiler.totalGanadoSinDesinfeccion());
        String totalGanadoCuerdas = String.valueOf(alquiler.totalGanadoCuerdas());
        
        Reportes repo = new Reportes(clienteAlquilerMayor, totalGanadoSinDesinfeccion, totalGanadoCuerdas);
        repo.setTitle("Reportes");
        repo.setVisible(true);
    }//GEN-LAST:event_btnReportesActionPerformed

    private void txtCantidadSemanasFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtCantidadSemanasFocusLost
        String text = txtCantidadSemanas.getText();
        try {
            int x = Integer.parseInt(text);
        } catch (NumberFormatException nfe) {
            JOptionPane.showMessageDialog(null, "La Cantidad de Semanas debe ser un número");
            txtCantidadSemanas.requestFocus();
        }
    }//GEN-LAST:event_txtCantidadSemanasFocusLost

    private void txtCantidadCuerdasFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtCantidadCuerdasFocusLost
        String text = txtCantidadCuerdas.getText();
        try {
            int x = Integer.parseInt(text);
        } catch (NumberFormatException nfe) {
            JOptionPane.showMessageDialog(null, "La Cantidad de Cuerdas debe ser un número");
            txtCantidadCuerdas.requestFocus();
        }
    }//GEN-LAST:event_txtCantidadCuerdasFocusLost

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Principal().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnGuardar;
    private javax.swing.JButton btnReportes;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JRadioButton rbtCuerdas;
    private javax.swing.JRadioButton rbtViento;
    private javax.swing.JTextField txtCantidadCuerdas;
    private javax.swing.JTextField txtCantidadSemanas;
    private javax.swing.JTextField txtNombreCliente;
    private javax.swing.JTextField txtNombreInstrumento;
    // End of variables declaration//GEN-END:variables
}
